MODULE Module1;

IMPORT
  SYSTEM, F:=Forms, S:=StdCtrl, W:=Windows, M:=Messages, C:=Controls, M2:=Module2, D:=Dialogs;

VAR
  Form*: TForm;
  
TYPE
  TForm  = POINTER TO RECORD(F.TForm)
  
    Button1: S.TButton;
    Button2: S.TButton;
    
    SubMenu,Sub2, Menu: W.HMENU;
    
    PROCEDURE & Create(Owner: C.TWinControl);
    BEGIN
      Create^(Owner);
      
      Left     := 0;
      Top      := 0;
      Width    := 640;
      Height   := 480;
      Caption  := 'Form1';
      DoubleBuffered:=TRUE;
      
      Position := F.poCenterCenter;
      
      NEW(Button1, SELF);
      Button1.onClick:=Button1Click;
      Button1.Caption:='';
     
      NEW(Button2, SELF);
      Button2.onClick:=Button2Click;
      Button2.Caption:='';
      Button2.Top:=300;
      
      Menu    := W.CreateMenu();
      SubMenu := W.CreateMenu();
      Sub2    := W.CreateMenu();
      
      W.AppendMenu(SubMenu,W.MF_STRING,101,'&New...');
      W.AppendMenu(SubMenu,W.MF_STRING,102,'&Open...');
      W.AppendMenu(SubMenu,W.MF_STRING,103,'&Save...');
      W.AppendMenu(SubMenu,W.MF_SEPARATOR,0,'-');
      W.AppendMenu(SubMenu,W.MF_STRING,104,'E&xit');
      
      W.AppendMenu(Sub2,W.MF_STRING,103,'&Save...');
      W.AppendMenu(Sub2,W.MF_SEPARATOR,0,'-');
      W.AppendMenu(Sub2,W.MF_STRING,104,'E&xit');
      W.AppendMenu(SubMenu,W.MF_POPUP,Sub2,'&Files');
      
      W.AppendMenu(Menu,W.MF_POPUP,SubMenu,'&Files');
      
      SubMenu := W.CreateMenu();
      W.AppendMenu(SubMenu,W.MF_STRING,201,'&Cut');
      W.AppendMenu(SubMenu,W.MF_STRING,202,'&Copy');
      W.AppendMenu(SubMenu,W.MF_STRING,203,'&Paste');
      W.AppendMenu(Menu,W.MF_POPUP,SubMenu,'&Edit');
      
      SubMenu := W.CreateMenu();
      W.AppendMenu(SubMenu,W.MF_STRING,301,'&Settings');
      W.AppendMenu(Menu,W.MF_POPUP,SubMenu,'&Options');
      W.AppendMenu(Menu,W.MF_STRING,0,'&Help');
      W.SetMenu(Handle,Menu);

    END Create;
    
    PROCEDURE Button1Click;
    BEGIN
      M2.Form.Show;         
    END Button1Click;
    
    PROCEDURE Button2Click;
    BEGIN
      M2.Form.Hide;         
    END Button2Click;
    
    PROCEDURE FormShow;
    BEGIN
      M2.Form.Show;
    END FormShow;
    
    PROCEDURE Paint;
    BEGIN
      Paint^;
      Canvas.SetColor(Color);      
      Canvas.Font.SetSize(19);
      Canvas.Font.SetColor(0FF0000H);
      Canvas.TextOut(20,40,'Canvas.Font.Name');          
    END Paint;
    
    PROCEDURE ReSize*;
    BEGIN
      Button2.Left:= Width-Button2.Width;
      Button2.Top := Height-Button2.Height;
    END ReSize;
 
    PROCEDURE WindowProc*(msg,wParam,lParam: LONGINT);  
    BEGIN
      WindowProc^(msg,wParam,lParam);  
      CASE msg OF
      |  M.WM_COMMAND:
                        CASE wParam OF
                          101 : D.ShowMessage('NEW');
                        ELSE
                        END;
      ELSE
      END;      
    END WindowProc;
    
  END;

BEGIN
  NEW(Form,NIL);
END Module1.
