(*#####################################################*)
(*# Messages for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Messages;

IMPORT
  SYSTEM, W:=Windows;
  
CONST
  WM_NULL*                          = 00000H;
  WM_CREATE*                        = 00001H;
  WM_DESTROY*                       = 00002H;
  WM_MOVE*                          = 00003H;
  WM_SIZE*                          = 00005H;
  WM_ACTIVATE*                      = 00006H;
  WM_SETFOCUS*                      = 00007H;
  WM_KILLFOCUS*                     = 00008H;
  WM_ENABLE*                        = 0000AH;
  WM_SETREDRAW*                     = 0000BH;
  WM_SETTEXT*                       = 0000CH;
  WM_GETTEXT*                       = 0000DH;
  WM_GETTEXTLENGTH*                 = 0000EH;
  WM_PAINT*                         = 0000FH;
  WM_CLOSE*                         = 00010H;
  WM_QUERYENDSESSION*               = 00011H;
  WM_QUIT*                          = 00012H;
  WM_QUERYOPEN*                     = 00013H;
  WM_ERASEBKGND*                    = 00014H;
  WM_SYSCOLORCHANGE*                = 00015H;
  WM_ENDSESSION*                    = 00016H;
  WM_SYSTEMERROR*                   = 00017H;
  WM_SHOWWINDOW*                    = 00018H;
  WM_CTLCOLOR*                      = 00019H;
  WM_WININICHANGE*                  = 0001AH;     
  WM_SETTINGCHANGE*                 = WM_WININICHANGE;   
  WM_DEVMODECHANGE*                 = 0001BH;
  WM_ACTIVATEAPP*                   = 0001CH;
  WM_FONTCHANGE*                    = 0001DH;
  WM_TIMECHANGE*                    = 0001EH;
  WM_CANCELMODE*                    = 0001FH;
  WM_SETCURSOR*                     = 00020H;
  WM_MOUSEACTIVATE*                 = 00021H;
  WM_CHILDACTIVATE*                 = 00022H;
  WM_QUEUESYNC*                     = 00023H;
  WM_GETMINMAXINFO*                 = 00024H;
  WM_PAINTICON*                     = 00026H;
  WM_ICONERASEBKGND*                = 00027H;
  WM_NEXTDLGCTL*                    = 00028H;
  WM_SPOOLERSTATUS*                 = 0002AH;
  WM_DRAWITEM*                      = 0002BH;
  WM_MEASUREITEM*                   = 0002CH;
  WM_DELETEITEM*                    = 0002DH;
  WM_VKEYTOITEM*                    = 0002EH;
  WM_CHARTOITEM*                    = 0002FH;
  WM_SETFONT*                       = 00030H;
  WM_GETFONT*                       = 00031H;
  WM_SETHOTKEY*                     = 00032H;
  WM_GETHOTKEY*                     = 00033H;
  WM_QUERYDRAGICON*                 = 00037H;
  WM_COMPAREITEM*                   = 00039H;
  WM_GETOBJECT*                     = 0003DH;
  WM_COMPACTING*                    = 00041H;
  WM_COMMNOTIFY*                    = 00044H;
  WM_WINDOWPOSCHANGING*             = 00046H;
  WM_WINDOWPOSCHANGED*              = 00047H;
  WM_POWER*                         = 00048H;
  WM_COPYDATA*                      = 0004AH;
  WM_CANCELJOURNAL*                 = 0004BH;
  WM_NOTIFY*                        = 0004EH;
  WM_INPUTLANGCHANGEREQUEST*        = 00050H;
  WM_INPUTLANGCHANGE*               = 00051H;
  WM_TCARD*                         = 00052H;
  WM_HELP*                          = 00053H;
  WM_USERCHANGED*                   = 00054H;
  WM_NOTIFYFORMAT*                  = 00055H;
  WM_CONTEXTMENU*                   = 0007BH;
  WM_STYLECHANGING*                 = 0007CH;
  WM_STYLECHANGED*                  = 0007DH;
  WM_DISPLAYCHANGE*                 = 0007EH;
  WM_GETICON*                       = 0007FH;
  WM_SETICON*                       = 00080H;
  WM_NCCREATE*                      = 00081H;
  WM_NCDESTROY*                     = 00082H;
  WM_NCCALCSIZE*                    = 00083H;
  WM_NCHITTEST*                     = 00084H;
  WM_NCPAINT*                       = 00085H;
  WM_NCACTIVATE*                    = 00086H;
  WM_GETDLGCODE*                    = 00087H;
  WM_NCMOUSEMOVE*                   = 000A0H;
  WM_NCLBUTTONDOWN*                 = 000A1H;
  WM_NCLBUTTONUP*                   = 000A2H;
  WM_NCLBUTTONDBLCLK*               = 000A3H;
  WM_NCRBUTTONDOWN*                 = 000A4H;
  WM_NCRBUTTONUP*                   = 000A5H;
  WM_NCRBUTTONDBLCLK*               = 000A6H;
  WM_NCMBUTTONDOWN*                 = 000A7H;
  WM_NCMBUTTONUP*                   = 000A8H;
  WM_NCMBUTTONDBLCLK*               = 000A9H;
  WM_NCXBUTTONDOWN*                 = 000ABH;
  WM_NCXBUTTONUP*                   = 000ACH;
  WM_NCXBUTTONDBLCLK*               = 000ADH;
  WM_INPUT*                         = 000FFH;
  WM_KEYFIRST*                      = 00100H;
  WM_KEYDOWN*                       = 00100H;
  WM_KEYUP*                         = 00101H;
  WM_CHAR*                          = 00102H;
  WM_DEADCHAR*                      = 00103H;
  WM_SYSKEYDOWN*                    = 00104H;
  WM_SYSKEYUP*                      = 00105H;
  WM_SYSCHAR*                       = 00106H;
  WM_SYSDEADCHAR*                   = 00107H;
  WM_UNICHAR*                       = 00109H;
  WM_KEYLAST*                       = 00109H;
  WM_INITDIALOG*                    = 00110H;
  WM_COMMAND*                       = 00111H;
  WM_SYSCOMMAND*                    = 00112H;
  WM_TIMER*                         = 00113H;
  WM_HSCROLL*                       = 00114H;
  WM_VSCROLL*                       = 00115H;
  WM_INITMENU*                      = 00116H;
  WM_INITMENUPOPUP*                 = 00117H;
  WM_MENUSELECT*                    = 0011FH;
  WM_MENUCHAR*                      = 00120H;
  WM_ENTERIDLE*                     = 00121H;
  WM_MENURBUTTONUP*                 = 00122H;
  WM_MENUDRAG*                      = 00123H;
  WM_MENUGETOBJECT*                 = 00124H;
  WM_UNINITMENUPOPUP*               = 00125H;
  WM_MENUCOMMAND*                   = 00126H;
  WM_CHANGEUISTATE*                 = 00127H;
  WM_UPDATEUISTATE*                 = 00128H;
  WM_QUERYUISTATE*                  = 00129H;
  WM_CTLCOLORMSGBOX*                = 00132H;
  WM_CTLCOLOREDIT*                  = 00133H;
  WM_CTLCOLORLISTBOX*               = 00134H;
  WM_CTLCOLORBTN*                   = 00135H;
  WM_CTLCOLORDLG*                   = 00136H;
  WM_CTLCOLORSCROLLBAR*             = 00137H;
  WM_CTLCOLORSTATIC*                = 00138H;
  WM_MOUSEFIRST*                    = 00200H;
  WM_MOUSEMOVE*                     = 00200H;
  WM_LBUTTONDOWN*                   = 00201H;
  WM_LBUTTONUP*                     = 00202H;
  WM_LBUTTONDBLCLK*                 = 00203H;
  WM_RBUTTONDOWN*                   = 00204H;
  WM_RBUTTONUP*                     = 00205H;
  WM_RBUTTONDBLCLK*                 = 00206H;
  WM_MBUTTONDOWN*                   = 00207H;
  WM_MBUTTONUP*                     = 00208H;
  WM_MBUTTONDBLCLK*                 = 00209H;
  WM_MOUSEWHEEL*                    = 0020AH;
  WM_MOUSELAST*                     = 0020AH;
  WM_PARENTNOTIFY*                  = 00210H;
  WM_ENTERMENULOOP*                 = 00211H;
  WM_EXITMENULOOP*                  = 00212H;
  WM_NEXTMENU*                      = 00213H;
  WM_SIZING*                        = 532;
  WM_CAPTURECHANGED*                = 533;
  WM_MOVING*                        = 534;
  WM_POWERBROADCAST*                = 536;
  WM_DEVICECHANGE*                  = 537;   
  WM_IME_STARTCOMPOSITION*          = 0010DH;
  WM_IME_ENDCOMPOSITION*            = 0010EH;
  WM_IME_COMPOSITION*               = 0010FH;
  WM_IME_KEYLAST*                   = 0010FH;
  WM_IME_SETCONTEXT*                = 00281H;
  WM_IME_NOTIFY*                    = 00282H;
  WM_IME_CONTROL*                   = 00283H;
  WM_IME_COMPOSITIONFULL*           = 00284H;
  WM_IME_SELECT*                    = 00285H;
  WM_IME_CHAR*                      = 00286H;
  WM_IME_REQUEST*                   = 00288H;   
  WM_IME_KEYDOWN*                   = 00290H;                  
  WM_IME_KEYUP*                     = 00291H;                    
  WM_MDICREATE*                     = 00220H;   
  WM_MDIDESTROY*                    = 00221H;                   
  WM_MDIACTIVATE*                   = 00222H;                  
  WM_MDIRESTORE*                    = 00223H;                   
  WM_MDINEXT*                       = 00224H;                      
  WM_MDIMAXIMIZE*                   = 00225H;                  
  WM_MDITILE*                       = 00226H;                      
  WM_MDICASCADE*                    = 00227H;                   
  WM_MDIICONARRANGE*                = 00228H;               
  WM_MDIGETACTIVE*                  = 00229H;                 
  WM_MDISETMENU*                    = 00230H;                   
  WM_ENTERSIZEMOVE*                 = 00231H;                
  WM_EXITSIZEMOVE*                  = 00232H;                 
  WM_DROPFILES*                     = 00233H;                    
  WM_MDIREFRESHMENU*                = 00234H;               
  WM_MOUSEHOVER*                    = 002A1H;                   
  WM_MOUSELEAVE*                    = 002A3H;                   
  WM_NCMOUSEHOVER*                  = 002A0H;                 
  WM_NCMOUSELEAVE*                  = 002A2H;                 
  WM_WTSSESSION_CHANGE*             = 002B1H;            
  WM_TABLET_FIRST*                  = 002C0H;                 
  WM_TABLET_LAST*                   = 002DFH;                  
  WM_CUT*                           = 00300H;     
  WM_COPY*                          = 00301H;    
  WM_PASTE*                         = 00302H;   
  WM_CLEAR*                         = 00303H;   
  WM_UNDO*                          = 00304H;    
  WM_RENDERFORMAT*                  = 00305H;                
  WM_RENDERALLFORMATS*              = 00306H;            
  WM_DESTROYCLIPBOARD*              = 00307H;            
  WM_DRAWCLIPBOARD*                 = 00308H;               
  WM_PAINTCLIPBOARD*                = 00309H;              
  WM_VSCROLLCLIPBOARD*              = 0030AH;            
  WM_SIZECLIPBOARD*                 = 0030BH;               
  WM_ASKCBFORMATNAME*               = 0030CH;             
  WM_CHANGECBCHAIN*                 = 0030DH;               
  WM_HSCROLLCLIPBOARD*              = 0030EH;            
  WM_QUERYNEWPALETTE*               = 0030FH;             
  WM_PALETTEISCHANGING*             = 00310H;                
  WM_PALETTECHANGED*                = 00311H;              
  WM_HOTKEY*                        = 00312H;                      
  WM_PRINT*                         = 791;            
  WM_PRINTCLIENT*                   = 792;             
  WM_APPCOMMAND*                    = 00319H;           
  WM_THEMECHANGED*                  = 0031AH;         
  WM_HANDHELDFIRST*                 = 856;           
  WM_HANDHELDLAST*                  = 863;            
  WM_PENWINFIRST*                   = 00380H;          
  WM_PENWINLAST*                    = 0038FH;           
  WM_COALESCE_FIRST*                = 00390H;       
  WM_COALESCE_LAST*                 = 0039FH;        
  WM_DDE_FIRST*                     = 003E0H;  
  WM_DDE_INITIATE*                  = WM_DDE_FIRST + 0;     
  WM_DDE_TERMINATE*                 = WM_DDE_FIRST + 1;    
  WM_DDE_ADVISE*                    = WM_DDE_FIRST + 2;       
  WM_DDE_UNADVISE*                  = WM_DDE_FIRST + 3;     
  WM_DDE_ACK*                       = WM_DDE_FIRST + 4;          
  WM_DDE_DATA*                      = WM_DDE_FIRST + 5;         
  WM_DDE_REQUEST*                   = WM_DDE_FIRST + 6;      
  WM_DDE_POKE*                      = WM_DDE_FIRST + 7;         
  WM_DDE_EXECUTE*                   = WM_DDE_FIRST + 8;      
  WM_DDE_LAST*                      = WM_DDE_FIRST + 8;  
  WM_APP*                           = 08000H;                        
  WM_USER*                          = 00400H; 
                        
  BN_CLICKED*                       = 0;                             
  BN_PAINT*                         = 1;                               
  BN_HILITE*                        = 2;                              
  BN_UNHILITE*                      = 3;                            
  BN_DISABLE*                       = 4;                             
  BN_DOUBLECLICKED*                 = 5;                       
  BN_PUSHED*                        = BN_HILITE;                      
  BN_UNPUSHED*                      = BN_UNHILITE;                  
  BN_DBLCLK*                        = BN_DOUBLECLICKED;               
  BN_SETFOCUS*                      = 6;                            
  BN_KILLFOCUS*                     = 7;
                             
  BM_GETCHECK*                      = 000F0H;                       
  BM_SETCHECK*                      = 000F1H;                       
  BM_GETSTATE*                      = 000F2H;                       
  BM_SETSTATE*                      = 000F3H;                       
  BM_SETSTYLE*                      = 000F4H;                       
  BM_CLICK*                         = 000F5H;                          
  BM_GETIMAGE*                      = 000F6H;                       
  BM_SETIMAGE*                      = 000F7H; 
                        
  LBN_ERRSPACE*                     = (-2);                        
  LBN_SELCHANGE*                    = 1;                          
  LBN_DBLCLK*                       = 2;                             
  LBN_SELCANCEL*                    = 3;                          
  LBN_SETFOCUS*                     = 4;                           
  LBN_KILLFOCUS*                    = 5; 
                           
  LB_ADDSTRING*                     = 00180H;                      
  LB_INSERTSTRING*                  = 00181H;                   
  LB_DELETESTRING*                  = 00182H;                   
  LB_SELITEMRANGEEX*                = 00183H;                 
  LB_RESETCONTENT*                  = 00184H;                   
  LB_SETSEL*                        = 00185H;                         
  LB_SETCURSEL*                     = 00186H;                      
  LB_GETSEL*                        = 00187H;                         
  LB_GETCURSEL*                     = 00188H;                      
  LB_GETTEXT*                       = 00189H;                        
  LB_GETTEXTLEN*                    = 0018AH;                     
  LB_GETCOUNT*                      = 0018BH;                       
  LB_SELECTSTRING*                  = 0018CH;                   
  LB_DIR*                           = 0018DH;                            
  LB_GETTOPINDEX*                   = 0018EH;                    
  LB_FINDSTRING*                    = 0018FH;                     
  LB_GETSELCOUNT*                   = 00190H;                    
  LB_GETSELITEMS*                   = 00191H;                    
  LB_SETTABSTOPS*                   = 00192H;                    
  LB_GETHORIZONTALEXTENT*           = 00193H;            
  LB_SETHORIZONTALEXTENT*           = 00194H;            
  LB_SETCOLUMNWIDTH*                = 00195H;                 
  LB_ADDFILE*                       = 00196H;                        
  LB_SETTOPINDEX*                   = 00197H;                    
  LB_GETITEMRECT*                   = 00198H;                    
  LB_GETITEMDATA*                   = 00199H;                    
  LB_SETITEMDATA*                   = 0019AH;                    
  LB_SELITEMRANGE*                  = 0019BH;                   
  LB_SETANCHORINDEX*                = 0019CH;                 
  LB_GETANCHORINDEX*                = 0019DH;                 
  LB_SETCARETINDEX*                 = 0019EH;                  
  LB_GETCARETINDEX*                 = 0019FH;                  
  LB_SETITEMHEIGHT*                 = 001A0H;                  
  LB_GETITEMHEIGHT*                 = 001A1H;                  
  LB_FINDSTRINGEXACT*               = 001A2H;                
  LB_SETLOCALE*                     = 001A5H;                      
  LB_GETLOCALE*                     = 001A6H;                      
  LB_SETCOUNT*                      = 001A7H;                       
  LB_INITSTORAGE*                   = 001A8H;                    
  LB_ITEMFROMPOINT*                 = 001A9H;                  
  LB_MSGMAX*                        = 432;                            
  
  CBN_ERRSPACE*                     = (-1);                        
  CBN_SELCHANGE*                    = 1;                          
  CBN_DBLCLK*                       = 2;                             
  CBN_SETFOCUS*                     = 3;                           
  CBN_KILLFOCUS*                    = 4;                          
  CBN_EDITCHANGE*                   = 5;                         
  CBN_EDITUPDATE*                   = 6;                         
  CBN_DROPDOWN*                     = 7;                           
  CBN_CLOSEUP*                      = 8;                            
  CBN_SELENDOK*                     = 9;                           
  CBN_SELENDCANCEL*                 = 10;                      
  
  CB_GETEDITSEL*                    = 00140H;                     
  CB_LIMITTEXT*                     = 00141H;                      
  CB_SETEDITSEL*                    = 00142H;                     
  CB_ADDSTRING*                     = 00143H;                      
  CB_DELETESTRING*                  = 00144H;                   
  CB_DIR*                           = 00145H;                            
  CB_GETCOUNT*                      = 00146H;                       
  CB_GETCURSEL*                     = 00147H;                      
  CB_GETLBTEXT*                     = 00148H;                      
  CB_GETLBTEXTLEN*                  = 00149H;                   
  CB_INSERTSTRING*                  = 0014AH;                   
  CB_RESETCONTENT*                  = 0014BH;                   
  CB_FINDSTRING*                    = 0014CH;                     
  CB_SELECTSTRING*                  = 0014DH;                   
  CB_SETCURSEL*                     = 0014EH;                      
  CB_SHOWDROPDOWN*                  = 0014FH;                   
  CB_GETITEMDATA*                   = 00150H;                    
  CB_SETITEMDATA*                   = 00151H;                    
  CB_GETDROPPEDCONTROLRECT*         = 00152H;          
  CB_SETITEMHEIGHT*                 = 00153H;                  
  CB_GETITEMHEIGHT*                 = 00154H;                  
  CB_SETEXTENDEDUI*                 = 00155H;                  
  CB_GETEXTENDEDUI*                 = 00156H;                  
  CB_GETDROPPEDSTATE*               = 00157H;                
  CB_FINDSTRINGEXACT*               = 00158H;                
  CB_SETLOCALE*                     = 345;                         
  CB_GETLOCALE*                     = 346;                         
  CB_GETTOPINDEX*                   = 347;                       
  CB_SETTOPINDEX*                   = 348;                       
  CB_GETHORIZONTALEXTENT*           = 349;               
  CB_SETHORIZONTALEXTENT*           = 350;               
  CB_GETDROPPEDWIDTH*               = 351;                   
  CB_SETDROPPEDWIDTH*               = 352;                   
  CB_INITSTORAGE*                   = 353;                       
  CB_MSGMAX*                        = 354;                            
  
  EN_SETFOCUS*                      = 00100H;                       
  EN_KILLFOCUS*                     = 00200H;                      
  EN_CHANGE*                        = 00300H;                         
  EN_UPDATE*                        = 00400H;                         
  EN_ERRSPACE*                      = 00500H;                       
  EN_MAXTEXT*                       = 00501H;                        
  EN_HSCROLL*                       = 00601H;                        
  EN_VSCROLL*                       = 00602H;                        
  
  EM_GETSEL*                        = 000B0H;                         
  EM_SETSEL*                        = 000B1H;                         
  EM_GETRECT*                       = 000B2H;                        
  EM_SETRECT*                       = 000B3H;                        
  EM_SETRECTNP*                     = 000B4H;                      
  EM_SCROLL*                        = 000B5H;                         
  EM_LINESCROLL*                    = 000B6H;                     
  EM_SCROLLCARET*                   = 000B7H;                    
  EM_GETMODIFY*                     = 000B8H;                      
  EM_SETMODIFY*                     = 000B9H;                      
  EM_GETLINECOUNT*                  = 000BAH;                   
  EM_LINEINDEX*                     = 000BBH;                      
  EM_SETHANDLE*                     = 000BCH;                      
  EM_GETHANDLE*                     = 000BDH;                      
  EM_GETTHUMB*                      = 000BEH;                       
  EM_LINELENGTH*                    = 000C1H;                     
  EM_REPLACESEL*                    = 000C2H;                     
  EM_GETLINE*                       = 000C4H;                        
  EM_LIMITTEXT*                     = 000C5H;                      
  EM_CANUNDO*                       = 000C6H;                        
  EM_UNDO*                          = 000C7H;                           
  EM_FMTLINES*                      = 000C8H;                       
  EM_LINEFROMCHAR*                  = 000C9H;                   
  EM_SETTABSTOPS*                   = 000CBH;                    
  EM_SETPASSWORDCHAR*               = 000CCH;                
  EM_EMPTYUNDOBUFFER*               = 000CDH;                
  EM_GETFIRSTVISIBLELINE*           = 000CEH;            
  EM_SETREADONLY*                   = 000CFH;                    
  EM_SETWORDBREAKPROC*              = 000D0H;               
  EM_GETWORDBREAKPROC*              = 000D1H;               
  EM_GETPASSWORDCHAR*               = 000D2H;                
  EM_SETMARGINS*                    = 211;                        
  EM_GETMARGINS*                    = 212;                        
  EM_SETLIMITTEXT*                  = EM_LIMITTEXT;             
  EM_GETLIMITTEXT*                  = 213;                      
  EM_POSFROMCHAR*                   = 214;                       
  EM_CHARFROMPOS*                   = 215;                       
  EM_SETIMESTATUS*                  = 216;                      
  EM_GETIMESTATUS*                  = 217;                      
  
  SBM_SETPOS*                       = 224;                           
  SBM_GETPOS*                       = 225;                           
  SBM_SETRANGE*                     = 226;                         
  SBM_SETRANGEREDRAW*               = 230;                   
  SBM_GETRANGE*                     = 227;                         
  SBM_ENABLE_ARROWS*                = 228;                    
  SBM_SETSCROLLINFO*                = 233;                    
  SBM_GETSCROLLINFO*                = 234;                    
  
  DM_GETDEFID*                      = (WM_USER+0);                  
  DM_SETDEFID*                      = (WM_USER+1);                  
  DM_REPOSITION*                    = (WM_USER+2);
                                                  
  PSM_PAGEINFO*                     = (WM_USER+100);               
  PSM_SHEETINFO*                    = (WM_USER+101);
  
TYPE
  MSG*                              =  W.MSG;

END Messages.