(*#####################################################*)
(*#  Windows for Oberon Portable Compiler and Linker  #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE Windows;

IMPORT
  SYSTEM, Kernel;

CONST
  NULL*                                     = 0;

  STD_INPUT_HANDLE*                         = -10;
  STD_OUTPUT_HANDLE*                        = -11;
  STD_ERROR_HANDLE*                         = -12;

  MAX_PATH*                                 = 260 (* {2, 8} *);

  IGNORE*                                   =  0 ;
  INFINITE*                                 =  -1 ;

  WAIT_FAILED*                              =  -1 ;
  WAIT_OBJECT_0*                            =  0 ;
  WAIT_ABANDONED*                           =  128 ;
  WAIT_ABANDONED_0*                         =  128 ;
  WAIT_TIMEOUT*                             =  258 ;
  WAIT_IO_COMPLETION*                       =  192 ;

  VK_LBUTTON*                               =  1 ;
  VK_RBUTTON*                               =  2 ;
  VK_CANCEL*                                =  3 ;
  VK_MBUTTON*                               =  4 ;
  VK_BACK*                                  =  8 ;
  VK_TAB*                                   =  9 ;
  VK_CLEAR*                                 =  12 ;
  VK_RETURN*                                =  13 ;
  VK_SHIFT*                                 =  16 ;
  VK_CONTROL*                               =  17 ;
  VK_MENU*                                  =  18 ;
  VK_PAUSE*                                 =  19 ;
  VK_CAPITAL*                               =  20 ;
  VK_ESCAPE*                                =  27 ;
  VK_SPACE*                                 =  32 ;
  VK_PRIOR*                                 =  33 ;
  VK_NEXT*                                  =  34 ;
  VK_END*                                   =  35 ;
  VK_HOME*                                  =  36 ;
  VK_LEFT*                                  =  37 ;
  VK_UP*                                    =  38 ;
  VK_RIGHT*                                 =  39 ;
  VK_DOWN*                                  =  40 ;
  VK_SELECT*                                =  41 ;
  VK_PRINT*                                 =  42 ;
  VK_EXECUTE*                               =  43 ;
  VK_SNAPSHOT*                              =  44 ;
  VK_INSERT*                                =  45 ;
  VK_DELETE*                                =  46 ;
  VK_HELP*                                  =  47 ;
  VK_LWIN*                                  =  91 ;
  VK_RWIN*                                  =  92 ;
  VK_APPS*                                  =  93 ;
  VK_NUMPAD0*                               =  96 ;
  VK_NUMPAD1*                               =  97 ;
  VK_NUMPAD2*                               =  98 ;
  VK_NUMPAD3*                               =  99 ;
  VK_NUMPAD4*                               =  100 ;
  VK_NUMPAD5*                               =  101 ;
  VK_NUMPAD6*                               =  102 ;
  VK_NUMPAD7*                               =  103 ;
  VK_NUMPAD8*                               =  104 ;
  VK_NUMPAD9*                               =  105 ;
  VK_MULTIPLY*                              =  106 ;
  VK_ADD*                                   =  107 ;
  VK_SEPARATOR*                             =  108 ;
  VK_SUBTRACT*                              =  109 ;
  VK_DECIMAL*                               =  110 ;
  VK_DIVIDE*                                =  111 ;
  VK_F1*                                    =  112 ;
  VK_F2*                                    =  113 ;
  VK_F3*                                    =  114 ;
  VK_F4*                                    =  115 ;
  VK_F5*                                    =  116 ;
  VK_F6*                                    =  117 ;
  VK_F7*                                    =  118 ;
  VK_F8*                                    =  119 ;
  VK_F9*                                    =  120 ;
  VK_F10*                                   =  121 ;
  VK_F11*                                   =  122 ;
  VK_F12*                                   =  123 ;
  VK_F13*                                   =  124 ;
  VK_F14*                                   =  125 ;
  VK_F15*                                   =  126 ;
  VK_F16*                                   =  127 ;
  VK_F17*                                   =  128 ;
  VK_F18*                                   =  129 ;
  VK_F19*                                   =  130 ;
  VK_F20*                                   =  131 ;
  VK_F21*                                   =  132 ;
  VK_F22*                                   =  133 ;
  VK_F23*                                   =  134 ;
  VK_F24*                                   =  135 ;
  VK_NUMLOCK*                               =  144 ;
  VK_SCROLL*                                =  145 ;
  VK_LSHIFT*                                =  160 ;
  VK_RSHIFT*                                =  161 ;
  VK_LCONTROL*                              =  162 ;
  VK_RCONTROL*                              =  163 ;
  VK_LMENU*                                 =  164 ;
  VK_RMENU*                                 =  165 ;
  VK_PROCESSKEY*                            =  229 ;
  VK_ATTN*                                  =  246 ;
  VK_CRSEL*                                 =  247 ;
  VK_EXSEL*                                 =  248 ;
  VK_EREOF*                                 =  249 ;
  VK_PLAY*                                  =  250 ;
  VK_ZOOM*                                  =  251 ;
  VK_NONAME*                                =  252 ;
  VK_PA1*                                   =  253 ;
  VK_OEM_CLEAR*                             =  254 ;

  KEY_EVENT*                                =  1;
  MOUSE_EVENT*                              =  2 ;
  WINDOW_BUFFER_SIZE_EVENT*                 =  4 ;
  MENU_EVENT*                               =  8 ;
  FOCUS_EVENT*                              =  16 ;
  
  FROM_LEFT_1ST_BUTTON_PRESSED*             =  {0};
  RIGHTMOST_BUTTON_PRESSED*                 =  {1};
  FROM_LEFT_2ND_BUTTON_PRESSED*             =  {2};
  FROM_LEFT_3RD_BUTTON_PRESSED*             =  {3};
  FROM_LEFT_4TH_BUTTON_PRESSED*             =  {4};
  
  MOUSE_MOVED*                              =  {0};
  DOUBLE_CLICK*                             =  {1};
  
  HWND_TOP*                                 = 0;
  HWND_BOTTOM*                              = 1;
  HWND_TOPMOST*                             = -1;
  HWND_NOTOPMOST*                           = -2;

  CTLCOLOR_MSGBOX*                          =  0 ;
  CTLCOLOR_EDIT*                            =  1 ;
  CTLCOLOR_LISTBOX*                         =  2 ;
  CTLCOLOR_BTN*                             =  3 ;
  CTLCOLOR_DLG*                             =  4 ;
  CTLCOLOR_SCROLLBAR*                       =  5 ;
  CTLCOLOR_STATIC*                          =  6 ;
  CTLCOLOR_MAX*                             =  7 ;
  
  COLOR_SCROLLBAR*                          =  0 ;
  COLOR_BACKGROUND*                         =  1 ;
  COLOR_ACTIVECAPTION*                      =  2 ;
  COLOR_INACTIVECAPTION*                    =  3 ;
  COLOR_MENU*                               =  4 ;
  COLOR_WINDOW*                             =  5 ;
  COLOR_WINDOWFRAME*                        =  6 ;
  COLOR_MENUTEXT*                           =  7 ;
  COLOR_WINDOWTEXT*                         =  8 ;
  COLOR_CAPTIONTEXT*                        =  9 ;
  COLOR_ACTIVEBORDER*                       =  10 ;
  COLOR_INACTIVEBORDER*                     =  11 ;
  COLOR_APPWORKSPACE*                       =  12 ;
  COLOR_HIGHLIGHT*                          =  13 ;
  COLOR_HIGHLIGHTTEXT*                      =  14 ;
  COLOR_BTNFACE*                            =  15 ;
  COLOR_BTNSHADOW*                          =  16 ;
  COLOR_GRAYTEXT*                           =  17 ;
  COLOR_BTNTEXT*                            =  18 ;
  COLOR_INACTIVECAPTIONTEXT*                =  19 ;
  COLOR_BTNHIGHLIGHT*                       =  20 ;
  COLOR_3DDKSHADOW*                         =  21 ;
  COLOR_3DLIGHT*                            =  22 ;
  COLOR_INFOTEXT*                           =  23 ;
  COLOR_INFOBK*                             =  24 ;
  COLOR_DESKTOP*                            =  1 ;
  COLOR_3DFACE*                             =  15 ;
  COLOR_3DSHADOW*                           =  16 ;
  COLOR_3DHIGHLIGHT*                        =  20 ;
  COLOR_3DHILIGHT*                          =  20 ;
  COLOR_BTNHILIGHT*                         =  20 ;

  BS_PUSHBUTTON*                            =  {};
  BS_DEFPUSHBUTTON*                         =  {0};
  BS_CHECKBOX*                              =  {1};
  BS_AUTOCHECKBOX*                          =  {0, 1};
  BS_RADIOBUTTON*                           =  {2};
  BS_3STATE*                                =  {0, 2};
  BS_AUTO3STATE*                            =  {1, 2};
  BS_GROUPBOX*                              =  {0..2};
  BS_USERBUTTON*                            =  {3};
  BS_AUTORADIOBUTTON*                       =  {0, 3};
  BS_OWNERDRAW*                             =  {0, 1, 3};
  BS_LEFTTEXT*                              =  {5};
  BS_TEXT*                                  =  {};
  BS_ICON*                                  =  {6};
  BS_BITMAP*                                =  {7};
  BS_LEFT*                                  =  {8};
  BS_RIGHT*                                 =  {9};
  BS_CENTER*                                =  {8, 9};
  BS_TOP*                                   =  {10};
  BS_BOTTOM*                                =  {11};
  BS_VCENTER*                               =  {10, 11};
  BS_PUSHLIKE*                              =  {12};
  BS_MULTILINE*                             =  {13};
  BS_NOTIFY*                                =  {14};
  BS_FLAT*                                  =  {15};
  BS_RIGHTBUTTON*                           =  {5};
  
  CS_VREDRAW*                               =  {0};
  CS_HREDRAW*                               =  {1};
  CS_KEYCVTWINDOW*                          =  {2};
  CS_DBLCLKS*                               =  {3};
  CS_OWNDC*                                 =  {5};
  CS_CLASSDC*                               =  {6};
  CS_PARENTDC*                              =  {7};
  CS_NOKEYCVT*                              =  {8};
  CS_NOCLOSE*                               =  {9};
  CS_SAVEBITS*                              =  {11};
  CS_BYTEALIGNCLIENT*                       =  {12};
  CS_BYTEALIGNWINDOW*                       =  {13};
  CS_GLOBALCLASS*                           =  {14};
  CS_IME*                                   =  {16};

  ES_LEFT*                                  =  {};
  ES_CENTER*                                =  {0};
  ES_RIGHT*                                 =  {1};
  ES_MULTILINE*                             =  {2};
  ES_UPPERCASE*                             =  {3};
  ES_LOWERCASE*                             =  {4};
  ES_PASSWORD*                              =  {5};
  ES_AUTOVSCROLL*                           =  {6};
  ES_AUTOHSCROLL*                           =  {7};
  ES_NOHIDESEL*                             =  {8};
  ES_OEMCONVERT*                            =  {10};
  ES_READONLY*                              =  {11};
  ES_WANTRETURN*                            =  {12};
  ES_NUMBER*                                =  {13};

  GWL_WNDPROC*                              =  -4 ;
  GWL_HINSTANCE*                            =  -6 ;
  GWL_HWNDPARENT*                           =  -8 ;
  GWL_STYLE*                                =  -16 ;
  GWL_EXSTYLE*                              =  -20 ;
  GWL_USERDATA*                             =  -21 ;
  GWL_ID*                                   =  -12 ;

  HTCAPTION*                                = 2;

  IDI_APPLICATION*                          = 1X;

  IDC_ARROW*                                =  32512 ;
  IDC_IBEAM*                                =  32513 ;
  IDC_WAIT*                                 =  32514 ;
  IDC_CROSS*                                =  32515 ;
  IDC_UPARROW*                              =  32516 ;
  IDC_SIZE*                                 =  32640 ;
  IDC_ICON*                                 =  32641 ;
  IDC_SIZENWSE*                             =  32642 ;
  IDC_SIZENESW*                             =  32643 ;
  IDC_SIZEWE*                               =  32644 ;
  IDC_SIZENS*                               =  32645 ;
  IDC_SIZEALL*                              =  32646 ;
  IDC_NO*                                   =  32648 ;
  IDC_APPSTARTING*                          =  32650 ;
  IDC_HELP*                                 =  32651 ;

  MB_OK*                                    =  {};
  MB_OKCANCEL*                              =  {0};
  MB_ABORTRETRYIGNORE*                      =  {1};
  MB_YESNOCANCEL*                           =  {0, 1};
  MB_YESNO*                                 =  {2};
  MB_RETRYCANCEL*                           =  {0, 2};
  MB_ICONHAND*                              =  {4};
  MB_ICONQUESTION*                          =  {5};
  MB_ICONEXCLAMATION*                       =  {4, 5};
  MB_ICONASTERISK*                          =  {6};
  MB_USERICON*                              =  {7};
  MB_ICONWARNING*                           =  {4, 5};
  MB_ICONERROR*                             =  {4};
  MB_ICONINFORMATION*                       =  {6};
  MB_ICONSTOP*                              =  {4};
  MB_DEFBUTTON1*                            =  {};
  MB_DEFBUTTON2*                            =  {8};
  MB_DEFBUTTON3*                            =  {9};
  MB_DEFBUTTON4*                            =  {8, 9};
  MB_APPLMODAL*                             =  {};
  MB_SYSTEMMODAL*                           =  {12};
  MB_TASKMODAL*                             =  {13};
  MB_HELP*                                  =  {14};
  MB_NOFOCUS*                               =  {15};
  MB_SETFOREGROUND*                         =  {16};
  MB_DEFAULT_DESKTOP_ONLY*                  =  {17};
  MB_TOPMOST*                               =  {18};
  MB_RIGHT*                                 =  {19};
  MB_RTLREADING*                            =  {20};
  MB_SERVICE_NOTIFICATION*                  =  {21};
  MB_TYPEMASK*                              =  {0..3};
  MB_ICONMASK*                              =  {4..7};
  MB_DEFMASK*                               =  {8..11};
  MB_MODEMASK*                              =  {12, 13};
  MB_MISCMASK*                              =  {14, 15};

  HWND_DESKTOP*                             = 0;

  SW_HIDE*                                  =  0 ;
  SW_SHOWNORMAL*                            =  1 ;
  SW_NORMAL*                                =  1 ;
  SW_SHOWMINIMIZED*                         =  2 ;
  SW_SHOWMAXIMIZED*                         =  3 ;
  SW_MAXIMIZE*                              =  3 ;
  SW_SHOWNOACTIVATE*                        =  4 ;
  SW_SHOW*                                  =  5 ;
  SW_MINIMIZE*                              =  6 ;
  SW_SHOWMINNOACTIVE*                       =  7 ;
  SW_SHOWNA*                                =  8 ;
  SW_RESTORE*                               =  9 ;
  SW_SHOWDEFAULT*                           =  10 ;
  SW_MAX*                                   =  10 ;

  SWP_SHOWWINDOW*                           =  {6};
  SWP_HIDEWINDOW*                           =  {7};

  WS_OVERLAPPED*                            =  {};
  WS_POPUP*                                 =  {31};
  WS_CHILD*                                 =  {30};
  WS_MINIMIZE*                              =  {29};
  WS_VISIBLE*                               =  {28};
  WS_DISABLED*                              =  {27};
  WS_CLIPSIBLINGS*                          =  {26};
  WS_CLIPCHILDREN*                          =  {25};
  WS_MAXIMIZE*                              =  {24};
  WS_CAPTION*                               =  {22, 23};
  WS_BORDER*                                =  {23};
  WS_DLGFRAME*                              =  {22};
  WS_VSCROLL*                               =  {21};
  WS_HSCROLL*                               =  {20};
  WS_SYSMENU*                               =  {19};
  WS_THICKFRAME*                            =  {18};
  WS_GROUP*                                 =  {17};
  WS_TABSTOP*                               =  {16};
  WS_MINIMIZEBOX*                           =  {17};
  WS_MAXIMIZEBOX*                           =  {16};
  WS_TILED*                                 =  {};
  WS_ICONIC*                                =  {29};
  WS_SIZEBOX*                               =  {18};
  WS_TILEDWINDOW*                           =  {16..19, 22, 23};
  WS_OVERLAPPEDWINDOW*                      =  {16..19, 22, 23};
  WS_POPUPWINDOW*                           =  {19, 23, 31};
  WS_CHILDWINDOW*                           =  {30};
  WS_EX_DLGMODALFRAME*                      =  {0};
  WS_EX_NOPARENTNOTIFY*                     =  {2};
  WS_EX_TOPMOST*                            =  {3};
  WS_EX_ACCEPTFILES*                        =  {4};
  WS_EX_TRANSPARENT*                        =  {5};
  WS_EX_MDICHILD*                           =  {6};
  WS_EX_TOOLWINDOW*                         =  {7};
  WS_EX_WINDOWEDGE*                         =  {8};
  WS_EX_CLIENTEDGE*                         =  {9};
  WS_EX_CONTEXTHELP*                        =  {10};
  WS_EX_RIGHT*                              =  {12};
  WS_EX_LEFT*                               =  {};
  WS_EX_RTLREADING*                         =  {13};
  WS_EX_LTRREADING*                         =  {};
  WS_EX_LEFTSCROLLBAR*                      =  {14};
  WS_EX_RIGHTSCROLLBAR*                     =  {};
  WS_EX_CONTROLPARENT*                      =  {16};
  WS_EX_STATICEDGE*                         =  {17};
  WS_EX_APPWINDOW*                          =  {18};
  WS_EX_OVERLAPPEDWINDOW*                   =  {8, 9};
  WS_EX_PALETTEWINDOW*                      =  {3, 7, 8};

  PFD_TYPE_RGBA*                            =  0 ;
  PFD_TYPE_COLORINDEX*                      =  1 ;
  PFD_MAIN_PLANE*                           =  0 ;
  PFD_OVERLAY_PLANE*                        =  1 ;
  PFD_UNDERLAY_PLANE*                       =  -1 ;
  PFD_DOUBLEBUFFER*                         =  {0};
  PFD_STEREO*                               =  {1};
  PFD_DRAW_TO_WINDOW*                       =  {2};
  PFD_DRAW_TO_BITMAP*                       =  {3};
  PFD_SUPPORT_GDI*                          =  {4};
  PFD_SUPPORT_OPENGL*                       =  {5};
  PFD_GENERIC_FORMAT*                       =  {6};
  PFD_NEED_PALETTE*                         =  {7};
  PFD_NEED_SYSTEM_PALETTE*                  =  {8};
  PFD_SWAP_EXCHANGE*                        =  {9};
  PFD_SWAP_COPY*                            =  {10};
  PFD_SWAP_LAYER_BUFFERS*                   =  {11};
  PFD_DOUBLEBUFFER_DONTCARE*                =  {30};
  PFD_STEREO_DONTCARE*                      =  {31};

  FS_LATIN1*                                =  {1};
  FS_LATIN2*                                =  {1};
  FS_CYRILLIC*                              =  {2};
  FS_GREEK*                                 =  {3};
  FS_TURKISH*                               =  {4};
  FS_HEBREW*                                =  {5};
  FS_ARABIC*                                =  {6};
  FS_BALTIC*                                =  {7};
  FS_THAI*                                  =  {16};
  FS_JISJAPAN*                              =  {17};
  FS_CHINESESIMP*                           =  {18};
  FS_WANSUNG*                               =  {19};
  FS_CHINESETRAD*                           =  {20};
  FS_JOHAB*                                 =  {21};
  FS_SYMBOL*                                =  {31};
  
  FF_DONTCARE*                              =  0 ;
  FF_ROMAN*                                 =  16 ;
  FF_SWISS*                                 =  32 ;
  FF_MODERN*                                =  48 ;
  FF_SCRIPT*                                =  64 ;
  FF_DECORATIVE*                            =  80 ;
  
  FW_DONTCARE*                              =  0 ;
  FW_THIN*                                  =  100 ;
  FW_EXTRALIGHT*                            =  200 ;
  FW_LIGHT*                                 =  300 ;
  FW_NORMAL*                                =  400 ;
  FW_MEDIUM*                                =  500 ;
  FW_SEMIBOLD*                              =  600 ;
  FW_BOLD*                                  =  700 ;
  FW_EXTRABOLD*                             =  800 ;
  FW_HEAVY*                                 =  900 ;
  FW_ULTRALIGHT*                            =  200 ;
  FW_REGULAR*                               =  400 ;
  FW_DEMIBOLD*                              =  600 ;
  FW_ULTRABOLD*                             =  800 ;
  FW_BLACK*                                 =  900 ;

  DEFAULT_CHARSET*                          =  1 ;
  SYMBOL_CHARSET*                           =  2 ;
  SHIFTJIS_CHARSET*                         =  128 ;
  HANGEUL_CHARSET*                          =  129 ;
  GB2312_CHARSET*                           =  134 ;
  CHINESEBIG5_CHARSET*                      =  136 ;
  OEM_CHARSET*                              =  255 ;
  JOHAB_CHARSET*                            =  130 ;
  HEBREW_CHARSET*                           =  177 ;
  ARABIC_CHARSET*                           =  178 ;
  GREEK_CHARSET*                            =  161 ;
  TURKISH_CHARSET*                          =  162 ;
  THAI_CHARSET*                             =  222 ;
  EASTEUROPE_CHARSET*                       =  238 ;
  RUSSIAN_CHARSET*                          =  204 ;
  MAC_CHARSET*                              =  77 ;
  BALTIC_CHARSET*                           =  186 ;

  DEFAULT_QUALITY*                          =  0 ;
  DRAFT_QUALITY*                            =  1 ;
  PROOF_QUALITY*                            =  2 ;
  NONANTIALIASED_QUALITY*                   =  3 ;
  ANTIALIASED_QUALITY*                      =  4 ;
  DEFAULT_PITCH*                            =  0 ;
  FIXED_PITCH*                              =  1 ;
  VARIABLE_PITCH*                           =  2 ;
  MONO_FONT*                                =  8 ;

  CLIP_DEFAULT_PRECIS*                      =  0 ;
  CLIP_CHARACTER_PRECIS*                    =  1 ;
  CLIP_STROKE_PRECIS*                       =  2 ;
  CLIP_MASK*                                =  15 ;
  CLIP_LH_ANGLES*                           =  16 ;
  CLIP_TT_ALWAYS*                           =  32 ;
  CLIP_EMBEDDED*                            =  128 ;

  OUT_DEFAULT_PRECIS*                       =  0 ;
  OUT_STRING_PRECIS*                        =  1 ;
  OUT_CHARACTER_PRECIS*                     =  2 ;
  OUT_STROKE_PRECIS*                        =  3 ;
  OUT_TT_PRECIS*                            =  4 ;
  OUT_DEVICE_PRECIS*                        =  5 ;
  OUT_RASTER_PRECIS*                        =  6 ;
  OUT_TT_ONLY_PRECIS*                       =  7 ;
  OUT_OUTLINE_PRECIS*                       =  8 ;

  PC_RESERVED*                              =  1 ;
  PC_EXPLICIT*                              =  2 ;
  PC_NOCOLLAPSE*                            =  4 ;

  TRANSPARENT*                              =  1 ;
  OPAQUE*                                   =  2 ;

  BKMODE_LAST*                              =  2 ;

  HORZRES*                                  =  8 ;
  VERTRES*                                  =  10 ;

  SRCCOPY*                                  =  13369376 ;
  SRCPAINT*                                 =  15597702 ;
  SRCAND*                                   =  8913094 ;
  SRCINVERT*                                =  6684742 ;
  SRCERASE*                                 =  4457256 ;
  NOTSRCCOPY*                               =  3342344 ;
  NOTSRCERASE*                              =  1114278 ;
  MERGECOPY*                                =  12583114 ;
  MERGEPAINT*                               =  12255782 ;
  PATCOPY*                                  =  15728673 ;
  PATPAINT*                                 =  16452105 ;
  PATINVERT*                                =  5898313 ;
  DSTINVERT*                                =  5570569 ;
  BLACKNESS*                                =  66 ;
  WHITENESS*                                =  16711778 ;

  DT_TOP*                                   =  {};
  DT_LEFT*                                  =  {};
  DT_CENTER*                                =  {0};
  DT_RIGHT*                                 =  {1};
  DT_VCENTER*                               =  {2};
  DT_BOTTOM*                                =  {3};
  DT_WORDBREAK*                             =  {4};
  DT_SINGLELINE*                            =  {5};
  DT_EXPANDTABS*                            =  {6};
  DT_TABSTOP*                               =  {7};
  DT_NOCLIP*                                =  {8};
  DT_EXTERNALLEADING*                       =  {9};
  DT_CALCRECT*                              =  {10};
  DT_NOPREFIX*                              =  {11};
  DT_INTERNAL*                              =  {12};
  DT_EDITCONTROL*                           =  {13};
  DT_PATH_ELLIPSIS*                         =  {14};
  DT_END_ELLIPSIS*                          =  {15};
  DT_MODIFYSTRING*                          =  {16};
  DT_RTLREADING*                            =  {17};
  DT_WORD_ELLIPSIS*                         =  {18};
  
  PS_SOLID*                                 =  0 ;
  PS_DASH*                                  =  1 ;
  PS_DOT*                                   =  2 ;
  PS_DASHDOT*                               =  3 ;
  PS_DASHDOTDOT*                            =  4 ;
  PS_NULL*                                  =  5 ;
  PS_INSIDEFRAME*                           =  6 ;
  PS_USERSTYLE*                             =  7 ;
  PS_ALTERNATE*                             =  8 ;
  PS_STYLE_MASK*                            =  15 ;
  PS_ENDCAP_ROUND*                          =  0 ;
  PS_ENDCAP_SQUARE*                         =  256 ;
  PS_ENDCAP_FLAT*                           =  512 ;
  PS_ENDCAP_MASK*                           =  3840 ;
  PS_JOIN_ROUND*                            =  0 ;
  PS_JOIN_BEVEL*                            =  4096 ;
  PS_JOIN_MITER*                            =  8192 ;
  PS_JOIN_MASK*                             =  61440 ;
  PS_COSMETIC*                              =  0 ;
  PS_GEOMETRIC*                             =  65536 ;
  PS_TYPE_MASK*                             =  983040 ;

  BS_SOLID*                                 =  0 ;
  BS_NULL*                                  =  1 ;
  BS_HOLLOW*                                =  1 ;
  BS_HATCHED*                               =  2 ;
  BS_PATTERN*                               =  3 ;
  BS_INDEXED*                               =  4 ;
  BS_DIBPATTERN*                            =  5 ;
  BS_DIBPATTERNPT*                          =  6 ;
  BS_PATTERN8X8*                            =  7 ;
  BS_DIBPATTERN8X8*                         =  8 ;
  
  HS_HORIZONTAL*                            =  0 ;
  HS_VERTICAL*                              =  1 ;
  HS_FDIAGONAL*                             =  2 ;
  HS_BDIAGONAL*                             =  3 ;
  HS_CROSS*                                 =  4 ;
  HS_DIAGCROSS*                             =  5 ;

  ETO_OPAQUE*                               =  {1};
  ETO_CLIPPED*                              =  {2};
  ETO_GLYPH_INDEX*                          =  {4};
  ETO_RTLREADING*                           =  {7};

  GENERIC_READ*                             =  {31};
  GENERIC_WRITE*                            =  {30};
  GENERIC_EXECUTE*                          =  {29};
  GENERIC_ALL*                              =  {28};
  
  MF_INSERT*                                =  {};
  MF_CHANGE*                                =  {7};
  MF_APPEND*                                =  {8};
  MF_DELETE*                                =  {9};
  MF_REMOVE*                                =  {12};
  MF_BYCOMMAND*                             =  {};
  MF_BYPOSITION*                            =  {10};
  MF_SEPARATOR*                             =  {11};
  MF_ENABLED*                               =  {};
  MF_GRAYED*                                =  {0};
  MF_DISABLED*                              =  {1};
  MF_UNCHECKED*                             =  {};
  MF_CHECKED*                               =  {3};
  MF_USECHECKBITMAPS*                       =  {9};
  MF_STRING*                                =  {};
  MF_BITMAP*                                =  {2};
  MF_OWNERDRAW*                             =  {8};
  MF_POPUP*                                 =  {4};
  MF_MENUBARBREAK*                          =  {5};
  MF_MENUBREAK*                             =  {6};
  MF_UNHILITE*                              =  {};
  MF_HILITE*                                =  {7};
  MF_DEFAULT*                               =  {12};
  MF_SYSMENU*                               =  {13};
  MF_HELP*                                  =  {14};
  MF_RIGHTJUSTIFY*                          =  {14};
  MF_MOUSESELECT*                           =  {15};
  MF_END*                                   =  {7};
  
  SM_CXSCREEN*                              =  0 ;
  SM_CYSCREEN*                              =  1 ;
  SM_CXVSCROLL*                             =  2 ;
  SM_CYHSCROLL*                             =  3 ;
  SM_CYCAPTION*                             =  4 ;
  SM_CXBORDER*                              =  5 ;
  SM_CYBORDER*                              =  6 ;
  SM_CXDLGFRAME*                            =  7 ;
  SM_CYDLGFRAME*                            =  8 ;
  SM_CYVTHUMB*                              =  9 ;
  SM_CXHTHUMB*                              =  10 ;
  SM_CXICON*                                =  11 ;
  SM_CYICON*                                =  12 ;
  SM_CXCURSOR*                              =  13 ;
  SM_CYCURSOR*                              =  14 ;
  SM_CYMENU*                                =  15 ;
  SM_CXFULLSCREEN*                          =  16 ;
  SM_CYFULLSCREEN*                          =  17 ;
  SM_CYKANJIWINDOW*                         =  18 ;
  SM_MOUSEPRESENT*                          =  19 ;
  SM_CYVSCROLL*                             =  20 ;
  SM_CXHSCROLL*                             =  21 ;
  SM_DEBUG*                                 =  22 ;
  SM_SWAPBUTTON*                            =  23 ;
  SM_RESERVED1*                             =  24 ;
  SM_RESERVED2*                             =  25 ;
  SM_RESERVED3*                             =  26 ;
  SM_RESERVED4*                             =  27 ;
  SM_CXMIN*                                 =  28 ;
  SM_CYMIN*                                 =  29 ;
  SM_CXSIZE*                                =  30 ;
  SM_CYSIZE*                                =  31 ;
  SM_CXFRAME*                               =  32 ;
  SM_CYFRAME*                               =  33 ;
  SM_CXMINTRACK*                            =  34 ;
  SM_CYMINTRACK*                            =  35 ;
  SM_CXDOUBLECLK*                           =  36 ;
  SM_CYDOUBLECLK*                           =  37 ;
  SM_CXICONSPACING*                         =  38 ;
  SM_CYICONSPACING*                         =  39 ;
  SM_MENUDROPALIGNMENT*                     =  40 ;
  SM_PENWINDOWS*                            =  41 ;
  SM_DBCSENABLED*                           =  42 ;
  SM_CMOUSEBUTTONS*                         =  43 ;
  SM_CXFIXEDFRAME*                          =  7 ;
  SM_CYFIXEDFRAME*                          =  8 ;
  SM_CXSIZEFRAME*                           =  32 ;
  SM_CYSIZEFRAME*                           =  33 ;
  SM_SECURE*                                =  44 ;
  SM_CXEDGE*                                =  45 ;
  SM_CYEDGE*                                =  46 ;
  SM_CXMINSPACING*                          =  47 ;
  SM_CYMINSPACING*                          =  48 ;
  SM_CXSMICON*                              =  49 ;
  SM_CYSMICON*                              =  50 ;
  SM_CYSMCAPTION*                           =  51 ;
  SM_CXSMSIZE*                              =  52 ;
  SM_CYSMSIZE*                              =  53 ;
  SM_CXMENUSIZE*                            =  54 ;
  SM_CYMENUSIZE*                            =  55 ;
  SM_ARRANGE*                               =  56 ;
  SM_CXMINIMIZED*                           =  57 ;
  SM_CYMINIMIZED*                           =  58 ;
  SM_CXMAXTRACK*                            =  59 ;
  SM_CYMAXTRACK*                            =  60 ;
  SM_CXMAXIMIZED*                           =  61 ;
  SM_CYMAXIMIZED*                           =  62 ;
  SM_NETWORK*                               =  63 ;
  SM_CLEANBOOT*                             =  67 ;
  SM_CXDRAG*                                =  68 ;
  SM_CYDRAG*                                =  69 ;
  SM_SHOWSOUNDS*                            =  70 ;
  SM_CXMENUCHECK*                           =  71 ;
  SM_CYMENUCHECK*                           =  72 ;
  SM_SLOWMACHINE*                           =  73 ;
  SM_MIDEASTENABLED*                        =  74 ;
  SM_CMETRICS*                              =  75 ;
          
TYPE
  BOOL*                                     = LONGINT;
  ADDRESS*                                  = LONGINT;
  ATOM*                                     = INTEGER;
  HANDLE*                                   = ADDRESS;
  HMODULE*                                  = ADDRESS;
  HINSTANCE*                                = ADDRESS;
  HGLOBAL*                                  = HANDLE;
  LPSTR*                                    = ADDRESS;
  HWND*                                     = HANDLE;

  UINT*                                     = LONGINT;
  MCIERROR*                                 = LONGINT;
  
  HGLRC*                                    = HANDLE;

  COLORREF*                                 = LONGINT;
  HDC*                                      = HANDLE;
  HGDIObj*                                  = HANDLE;
  HPEN*                                     = HGDIObj;
  HFONT*                                    = HGDIObj;
  HBRUSH*                                   = HGDIObj;
  HRGN*                                     = HGDIObj;
  HBITMAP*                                  = HGDIObj;

  HICON*                                    = HANDLE;
  HCURSOR*                                  = HANDLE;
  HMENU*                                    = HANDLE;
  HPALETTE*                                 = HANDLE;
  HACCEL*                                   = HANDLE;
  HHOOK*                                    = HANDLE;

  WPARAM*                                   = LONGINT;
  LPARAM*                                   = LONGINT;
  LRESULT*                                  = LONGINT;

  PtrSTR*                                   = LPSTR;
  PtrWSTR*                                  = LPSTR;

  COORD*                                    = RECORD [NOTAG]
    X*: INTEGER;
    Y*: INTEGER;
  END;

  RECT* = RECORD [NOTAG]
    left*         : LONGINT;
    top*          : LONGINT;
    right*        : LONGINT;
    bottom*       : LONGINT;
  END;
  
  SMALL_RECT*                               =  RECORD [NOTAG]
    left*         : INTEGER;
    top*          : INTEGER;
    right*        : INTEGER;
    bottom*       : INTEGER;
  END;

  CHAR_INFO*                                =  RECORD [NOTAG]
    Char*         : CHAR;
    Attributes*   : INTEGER;
  END;

  CONSOLE_SCREEN_BUFFER_INFO*               =  RECORD [NOTAG]
    dwSize*          : COORD;
    dwCursorPosition*: COORD;
    wAttributes*: INTEGER;
    srWindow*: SMALL_RECT;
    dwMaximumWindowSize*: COORD;
  END;

  CONSOLE_CURSOR_INFO*                      =  RECORD [NOTAG]
    dwSize*: LONGINT;
    bVisible*: BOOL;
  END;

  HANDLER_ROUTINE*                          =  PROCEDURE (CtrlType: LONGINT): BOOL;

  KEY_EVENT_RECORD*                         =  RECORD [NOTAG]
    bKeyDown*: BOOL;
    wRepeatCount*: INTEGER;
    wVirtualKeyCode*: INTEGER;
    wVirtualScanCode*: INTEGER;
    (*uChar* : RECORD [NOTAG] *)
      UnicodeChar*: CHAR;
      AsciiChar*  : CHAR;
    (*END; *)
    dwControlKeyState*: SET;
  END;
  PtrKEY_EVENT_RECORD*                      =  POINTER TO KEY_EVENT_RECORD;

  MOUSE_EVENT_RECORD*                       =  RECORD [NOTAG]
    dwMousePosition*: COORD;
    dwButtonState*: SET;
    dwControlKeyState*: SET;
    dwEventFlags*: SET;
  END;
  PtrMOUSE_EVENT_RECORD*                    =  POINTER TO MOUSE_EVENT_RECORD;

  WINDOW_BUFFER_SIZE_RECORD*                =  RECORD [NOTAG]
    dwSize*: COORD;
  END;
  PtrWINDOW_BUFFER_SIZE_RECORD*             =  POINTER TO WINDOW_BUFFER_SIZE_RECORD;

  MENU_EVENT_RECORD*                        =  RECORD [NOTAG]
    dwCommandId*: LONGINT;
  END;
  PtrMENU_EVENT_RECORD*                     =  POINTER TO MENU_EVENT_RECORD;

  FOCUS_EVENT_RECORD*                       =  RECORD [NOTAG]
    bSetFocus*: BOOL;
  END;

  INPUT_RECORD*                             =  RECORD [NOTAG]
    EventType*: INTEGER;
    Event*: RECORD [NOTAG]
      KeyEvent*              : KEY_EVENT_RECORD;
      MouseEvent*            : MOUSE_EVENT_RECORD;
      WindowBufferSizeEvent* : WINDOW_BUFFER_SIZE_RECORD;
      MenuEvent*             : MENU_EVENT_RECORD;
      FocusEvent*            : FOCUS_EVENT_RECORD;
    END;
  END;

  INPUT_RECORD_X*                           =  RECORD [NOTAG]
    EventType*: INTEGER;
    Event*: RECORD [NOTAG]
      Data*: ARRAY 32 OF CHAR;
    END;
  END;
  
  POINT*                                    =  RECORD [NOTAG]
    x*: LONGINT;
    y*: LONGINT;
  END;

  MSG*                                      =  RECORD [NOTAG]
    hwnd*   : HWND;
    message*: LONGINT;
    wParam* : WPARAM;
    lParam* : LPARAM;
    time*   : LONGINT;
    pt*     : POINT;
  END;

  WNDPROC*    = PROCEDURE [WINAPI] (hwnd: HWND; uMsg: LONGINT; wParam: WPARAM; lParam: LPARAM): LRESULT;

  WNDCLASSEXA*                              =  RECORD [NOTAG]
    cbSize*: LONGINT;
    style*: SET;
    lpfnWndProc*: WNDPROC;
    cbClsExtra*: LONGINT;
    cbWndExtra*: LONGINT;
    hInstance*: HINSTANCE;
    hIcon*: HICON;
    hCursor*: HCURSOR;
    hbrBackground*: HBRUSH;
    lpszMenuName*: PtrSTR;
    lpszClassName*: PtrSTR;
    hIconSm*: HICON;
  END;
  PtrWNDCLASSEXA*                           =  POINTER TO WNDCLASSEXA;

  WNDCLASSEXW*                              =  RECORD [NOTAG]
    cbSize*: LONGINT;
    style*: SET;
    lpfnWndProc*: WNDPROC;
    cbClsExtra*: LONGINT;
    cbWndExtra*: LONGINT;
    hInstance*: HINSTANCE;
    hIcon*: HICON;
    hCursor*: HCURSOR;
    hbrBackground*: HBRUSH;
    lpszMenuName*: PtrWSTR;
    lpszClassName*: PtrWSTR;
    hIconSm*: HICON;
  END;
  PtrWNDCLASSEXW*                           =  POINTER TO WNDCLASSEXW;

  WNDCLASSEX*                               =  WNDCLASSEXA;
  PtrWNDCLASSEX*                            =  PtrWNDCLASSEXA;
  WNDCLASSA*                                =  RECORD [NOTAG]
    style*: SET;
    lpfnWndProc*: WNDPROC;
    cbClsExtra*: LONGINT;
    cbWndExtra*: LONGINT;
    hInstance*: HINSTANCE;
    hIcon*: HICON;
    hCursor*: HCURSOR;
    hbrBackground*: HBRUSH;
    lpszMenuName*: PtrSTR;
    lpszClassName*: PtrSTR;
  END;
  PtrWNDCLASSA*                             =  POINTER TO WNDCLASSA;

  WNDCLASSW*                                =  RECORD [NOTAG]
    style*: SET;
    lpfnWndProc*: WNDPROC;
    cbClsExtra*: LONGINT;
    cbWndExtra*: LONGINT;
    hInstance*: HINSTANCE;
    hIcon*: HICON;
    hCursor*: HCURSOR;
    hbrBackground*: HBRUSH;
    lpszMenuName*: PtrWSTR;
    lpszClassName*: PtrWSTR;
  END;
  PtrWNDCLASSW*                             =  POINTER TO WNDCLASSW;
  WNDCLASS*                                 =  WNDCLASSA;
  PtrWNDCLASS*                              =  PtrWNDCLASSA;
  
  PAINTSTRUCT*                              =  RECORD [NOTAG]
    hdc*: HDC;
    fErase*: BOOL;
    rcPaint*: RECT;
    fRestore*: BOOL;
    fIncUpdate*: BOOL;
    rgbReserved*: ARRAY [NOTAG] 32 OF CHAR;
  END;
  PtrPAINTSTRUCT*                           =  POINTER TO PAINTSTRUCT;

  FONTNAME* = ARRAY [NOTAG] 32 OF CHAR;
  
  LOGFONTA*                                 =  RECORD [NOTAG]
    lfHeight*: LONGINT;
    lfWidth*: LONGINT;
    lfEscapement*: LONGINT;
    lfOrientation*: LONGINT;
    lfWeight*: LONGINT;
    lfItalic*: CHAR;
    lfUnderline*: CHAR;
    lfStrikeOut*: CHAR;
    lfCharSet*: CHAR;
    lfOutPrecision*: CHAR;
    lfClipPrecision*: CHAR;
    lfQuality*: CHAR;
    lfPitchAndFamily*: CHAR;
    lfFaceName*: ARRAY [NOTAG] 32 OF CHAR;
  END;
  PtrLOGFONTA* = POINTER TO LOGFONTA;
  
  LOGFONT*                                  =  RECORD [NOTAG]
    lfHeight*: LONGINT;
    lfWidth*: LONGINT;
    lfEscapement*: LONGINT;
    lfOrientation*: LONGINT;
    lfWeight*: LONGINT;
    lfItalic*: LONGINT;
    lfUnderline*: LONGINT;
    lfStrikeOut*: LONGINT;
    lfCharSet*: LONGINT;
    lfOutPrecision*: LONGINT;
    lfClipPrecision*: LONGINT;
    lfQuality*: LONGINT;
    lfPitchAndFamily*: LONGINT;
    lfFaceName*: LPSTR;
  END;
  
  LOGBRUSH*                                 =  RECORD [NOTAG]
    lbStyle*: LONGINT;
    lbColor*: COLORREF;
    lbHatch*: LONGINT;
  END;
  PtrLOGBRUSH*                              =  POINTER TO LOGBRUSH;

  LOGPEN*                                   =  RECORD [NOTAG]
    lopnStyle*: LONGINT;
    lopnWidth*: POINT;
    lopnColor*: COLORREF;
  END;

  TSIZE*                                     =  RECORD [NOTAG]
    cx*: LONGINT;
    cy*: LONGINT;
  END;

  SECURITY_ATTRIBUTES*                      =  RECORD [NOTAG]
    nLength*: LONGINT;
    lpSecurityDescriptor*: LONGINT;
    bInheritHandle*: BOOL;
  END;
  
VAR
  hInstance*                    : HINSTANCE;
  
  (* KERNEL32 *)
  AllocConsole-                 : PROCEDURE [WINAPI] (): BOOL;
  GetStdHandle-                 : PROCEDURE [WINAPI] (nStdHandle: LONGINT): HANDLE;
  SetStdHandle-                 : PROCEDURE [WINAPI] (nStdHandle: LONGINT; hHandle: HANDLE): BOOL;
  WriteFile-                    : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToWrite: LONGINT; VAR lpNumberOfBytesWritten: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  ReadFile-                     : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToRead: LONGINT; VAR lpNumberOfBytesRead: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  CreateFile-                   : PROCEDURE [WINAPI] (lpFileName: LPSTR; dwDesiredAccess: SET; dwShareMode: SET; VAR lpSecurityAttributes: SECURITY_ATTRIBUTES; dwCreationDisposition: LONGINT; dwFlagsAndAttributes: SET; hTemplateFile: HANDLE): HANDLE;
  
  SetConsoleCursorPosition1-    : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; dwCursorPosition: COORD): BOOL;
  SetConsoleCursorPosition-     : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; dwCursorPosition: LONGINT): BOOL;
  SetConsoleTitle-              : PROCEDURE [WINAPI] (lpConsoleTitle: ARRAY [NOTAG] OF CHAR): BOOL;
  SetConsoleTextAttribute-      : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; wAttributes: INTEGER): BOOL;
  FillConsoleOutputCharacter-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; cCharacter: CHAR; nLength: LONGINT; dwWriteCoord: LONGINT; VAR lpNumberOfCharsWritten: LONGINT): BOOL;
  FillConsoleOutputAttribute-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; wAttribute: INTEGER; nLength: LONGINT; dwWriteCoord: LONGINT; VAR lpNumberOfAttrsWritten: LONGINT): BOOL;
  GetLargestConsoleWindowSize-  : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE): INTEGER;
  GetConsoleScreenBufferInfo-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleScreenBufferInfo: CONSOLE_SCREEN_BUFFER_INFO): BOOL;
  SetConsoleScreenBufferSize-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; dwSize: LONGINT): BOOL;
  ScrollConsoleScreenBuffer-    : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpScrollRectangle: SMALL_RECT; VAR lpClipRectangle: SMALL_RECT; dwDestinationOrigin: LONGINT; VAR lpFill: CHAR_INFO): BOOL;
  GetConsoleCursorInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleCursorInfo: CONSOLE_CURSOR_INFO): BOOL;
  SetConsoleCursorInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleCursorInfo: CONSOLE_CURSOR_INFO): BOOL;
  SetConsoleWindowInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; bAbsolute: BOOL; VAR lpConsoleWindow: SMALL_RECT): BOOL;
  WaitForSingleObjectEx-        : PROCEDURE [WINAPI] (hHandle: HANDLE; dwMilliseconds: LONGINT; bAlertable: BOOL): LONGINT;
  ReadConsoleInput-             : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpBuffer: INPUT_RECORD; nLength: LONGINT; VAR lpNumberOfEventsRead: LONGINT): BOOL;
  ReadConsoleInputX-            : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpBuffer: INPUT_RECORD_X; nLength: LONGINT; VAR lpNumberOfEventsRead: LONGINT): BOOL;

  GetNumberOfConsoleInputEvents- : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpNumberOfEvents: LONGINT): BOOL;
  
  mciSendString-                : PROCEDURE [WINAPI] (lpstrCommand: ARRAY [NOTAG] OF CHAR; VAR lpstrReturnString: LPSTR; uReturnLength: UINT; hWndCallback: HWND): MCIERROR;
  SetConsoleFont-               : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; NumberFont: LONGINT):BOOL;
  CloseHandle-                  : PROCEDURE [WINAPI] (hObject: HANDLE): BOOL;
    
  (* USER32 *)
  PostQuitMessage-        : PROCEDURE [WINAPI] (nExitCode: LONGINT);
  LoadIcon-               : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpIconName: ARRAY [NOTAG] OF CHAR):HICON;
  LoadCursor-             : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpCursorName: LPSTR): HCURSOR;
  CreateWindowEx-         : PROCEDURE [WINAPI] (dwExStyle: SET; lpClassName, lpWindowName: ARRAY [NOTAG] OF CHAR; dwStyle: SET; x, y, nWidth, nHeight: LONGINT; hWndParent: HWND; hMenu: HMENU; hInstance: HINSTANCE; lpParam: LONGINT): HWND;
  CreateWindow-           : PROCEDURE [WINAPI] (lpClassName,lpWindowName: ARRAY [NOTAG] OF CHAR;dwStyle: SET; X, Y, nWidth, nHeight: LONGINT; hWndParent: HWND;hMenu: HMENU; hInstance: HINSTANCE; lpParam: LONGINT): HWND;
  ShowWindow-             : PROCEDURE [WINAPI] (hWnd: HWND; nCmdShow: LONGINT): BOOL;
  UnregisterClass-        : PROCEDURE [WINAPI] (lpClassName: ARRAY [NOTAG] OF CHAR; hInstance: HINSTANCE): BOOL;
  RegisterClassEx-        : PROCEDURE [WINAPI] (VAR lpwcx: WNDCLASSEX): ATOM;
  GetMessage-             : PROCEDURE [WINAPI] (VAR lpMsg: MSG; hWnd: HWND; wMsgFilterMin, wMsgFilterMax: LONGINT): LONGINT;
  TranslateMessage-       : PROCEDURE [WINAPI] (VAR lpMsg: MSG): BOOL;
  DispatchMessage-        : PROCEDURE [WINAPI] (VAR lpMsg: MSG): LONGINT;
  DefWindowProc-          : WNDPROC;
  UpdateWindow-           : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  GetWindowRect-          : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: RECT): BOOL;
  BeginPaint-             : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPaint: PAINTSTRUCT): HDC;
  EndPaint-               : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPaint: PAINTSTRUCT): BOOL;
  GetSysColor-            : PROCEDURE [WINAPI] (nIndex: LONGINT): LONGINT;
  GetFocus-               : PROCEDURE [WINAPI] (): LONGINT;
  SendMessage-            : PROCEDURE [WINAPI] (hWnd: HWND; msg, wParam, lParam: LONGINT): LONGINT;
  SetWindowLong-          : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT; dwNewLong: SET): LONGINT;
  GetWindowLong-          : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT): SET;
  GetDesktopWindow-       : PROCEDURE [WINAPI] (): HWND;
  SetWindowPos-           : PROCEDURE [WINAPI] (hWnd: HWND; hWndInsertAfter: HWND;X: LONGINT; Y: LONGINT; cx: LONGINT; cy: LONGINT; uFlags: SET): BOOL;
  MessageBox-             : PROCEDURE [WINAPI] (hwnd: HWND; text, caption: ARRAY [NOTAG] OF CHAR; type: SET): LONGINT;
  GetDC-                  : PROCEDURE [WINAPI] (hWnd: HWND): HDC;
  GetAsyncKeyState-       : PROCEDURE [WINAPI] (vKey: LONGINT): SHORTINT;
  PeekMessage-            : PROCEDURE [WINAPI] (VAR lpMsg: MSG; hWnd: HWND; wMsgFilterMin, wMsgFilterMax, wRemoveMsg: LONGINT): BOOLEAN;
  GetClientRect-          : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: RECT): BOOL;
  DrawText-               : PROCEDURE [WINAPI] (hDC: HDC; lpString: LPSTR; nCount: LONGINT; VAR lpRect: RECT; uFormat: SET): LONGINT;
  CreateFontIndirect-     : PROCEDURE [WINAPI] (VAR p0: LOGFONTA): HFONT;
  InvalidateRect-         : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: RECT; bErase: BOOLEAN): BOOL;
  ReleaseDC-              : PROCEDURE [WINAPI] (hWnd: HWND; hDC: HDC): LONGINT;
  DrawFocusRect-          : PROCEDURE [WINAPI] (hDC: HDC; VAR lprc: RECT): BOOL;
  FillRect-               : PROCEDURE [WINAPI] (hDC: HDC; VAR lprc: RECT; hbr: HBRUSH): LONGINT;
  FrameRect-              : PROCEDURE [WINAPI] (hDC: HDC; VAR lprc: RECT; hbr: HBRUSH): LONGINT;
  SetParent-              : PROCEDURE [WINAPI] (hWnd: HWND; newWnd: HWND): HWND;
  
  SetWindowText-          : PROCEDURE [WINAPI] (hWnd: HWND; lpString: PtrSTR): BOOL;
  GetWindowText-          : PROCEDURE [WINAPI] (hWnd: HWND; lpString: PtrSTR; nMaxCount: LONGINT): LONGINT;
  MoveWindow-             : PROCEDURE [WINAPI] (hWnd: HWND; X: LONGINT; Y: LONGINT; nWidth: LONGINT; nHeight: LONGINT; bRepaint: BOOL): BOOL;
  
  CreateMenu-             : PROCEDURE [WINAPI] (): HMENU;
  CreatePopupMenu-        : PROCEDURE [WINAPI] (): HMENU;
  AppendMenu-             : PROCEDURE [WINAPI] (hMenu: HMENU; uFlags: SET; uIDNewItem: HMENU; lpNewItem: ARRAY [NOTAG] OF CHAR): BOOL;
  SetMenu-                : PROCEDURE [WINAPI] (hWnd: HWND; hMenu: HMENU): BOOL;
  GetSystemMetrics-       : PROCEDURE [WINAPI] (nIndex: LONGINT): LONGINT;
    
  (* GDI2.DLL *)
  CreateFont-             : PROCEDURE [WINAPI] (p0:  LONGINT; p1:  LONGINT; p2:  LONGINT; p3: LONGINT;
                                          p4:  LONGINT; p5:  LONGINT; p6:  LONGINT; p7: LONGINT; p8: LONGINT; p9: LONGINT;
                                          p10: LONGINT; p11: LONGINT; p12: LONGINT; p13: LPSTR): HFONT;
  DeleteObject-           : PROCEDURE [WINAPI] (p0: HGDIObj): BOOL;
  DeleteDC-               : PROCEDURE [WINAPI] (p0: HDC): BOOL;
  SetBkMode-              : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT): LONGINT;
  SelectObject-           : PROCEDURE [WINAPI] (p0: HDC; p1: HGDIObj): HGDIObj;
  SwapBuffers-            : PROCEDURE [WINAPI] (DC: HDC): BOOL;
  CreateCompatibleDC-     : PROCEDURE [WINAPI] (p0: HDC): HDC;
  CreateCompatibleBitmap- : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT): HBITMAP;
  GetDeviceCaps-          : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT): LONGINT;
  BitBlt-                 : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: HDC; p6: LONGINT; p7: LONGINT; p8: LONGINT): BOOL;
  PatBlt-                 : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: LONGINT): BOOL;
  CreatePen-              : PROCEDURE [WINAPI] (p0: LONGINT; p1: LONGINT; p2: COLORREF): HPEN;
  CreateHatchBrush-       : PROCEDURE [WINAPI] (p0: LONGINT; p1: COLORREF): HBRUSH;
  CreateSolidBrush-       : PROCEDURE [WINAPI] (p0: COLORREF): HBRUSH;
  CreateBrushIndirect-    : PROCEDURE [WINAPI] (VAR p0: LOGBRUSH): HBRUSH;
  CreatePenIndirect-      : PROCEDURE [WINAPI] (VAR p0: LOGPEN): HPEN;
  ExtTextOut-             : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: SET; VAR p4: RECT; p5: LPSTR; p6: LONGINT; VAR p7: LONGINT): BOOL;
  SetTextColor-           : PROCEDURE [WINAPI] (p0: HDC; p1: COLORREF): COLORREF;

  LineTo-                 : PROCEDURE [WINAPI] (DC: HDC; X, Y: LONGINT): BOOL;
  MoveToEx-               : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; VAR p3: POINT): BOOL;
  Ellipse-                : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT): BOOL;
  FloodFill-              : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: COLORREF): BOOL;
  Rectangle-              : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT): BOOL;
  RoundRect-              : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: LONGINT; p6: LONGINT): BOOL;
  
PROCEDURE Shutdown* ();
BEGIN
  Kernel.Shutdown0(0);
END Shutdown;

PROCEDURE ExitProcess* ();
BEGIN
  Kernel.ExitProcess(0);
END ExitProcess;

BEGIN
  hInstance := Kernel.GetModuleHandle(NIL);
END Windows.
