(*#####################################################*)
(*#   Forms for Oberon Portable Compiler and Linker   #*)
(*#     ( https://sourceforge.net/projects/opcl )     #*)
(*# Version 1.0 for Win32: 9x,NT,Me,2k,XP,2k3,Vista,7 #*)
(*#  It is free for commercial & non-commercial use.  #*)
(*#                                                   #*)
(*# Copyright (C) 2011-2012, Serg Atantsov            #*)
(*#     e-mail Web_2.0@mail.ru     ICQ 200972129      #*)
(*#                                                   #*)
(*# Copyright (C) 2007-2012, Oleg N. Cher             #*)
(*#  www.zx.oberon2.ru e-mail allot@bk.ru ICQ 2208403 #*)
(*#####################################################*)

MODULE StdCtrl;

IMPORT
  SYSTEM, W:=Windows, M:=Messages, C:=Controls;

TYPE    
  ClickProc      = PROCEDURE {DELEGATE};
  TButton*       = POINTER TO RECORD (C.TWinControl)
  
    onClick*: ClickProc;
    
    PROCEDURE & Create*(Owner: C.TWinControl);
    VAR
      Style: SET;
    BEGIN 
      Create^(Owner);
      Width:=100;
      Height:=25;
      Style:=W.BS_PUSHBUTTON+W.WS_CHILD+W.WS_VISIBLE+W.WS_TABSTOP+W.WS_CLIPSIBLINGS;
      Handle := W.CreateWindowEx(
        W.WS_EX_APPWINDOW,'BUTTON',Caption,Style,
        Left, Top, Width, Height,
        Owner.Handle, SELF_ID, W.hInstance, 0
      ); 
    END Create;

    PROCEDURE WindowProc*(msg,wParam,lParam: LONGINT);
    BEGIN
      WindowProc^(msg,wParam,lParam);
      CASE msg OF 
         M.WM_COMMAND: onClick;                           
      ELSE
      END;      
    END WindowProc;
    
  END;
   
END StdCtrl.